; Exemplo de macro para desenhar uma porta de uma folha
; indicando por pontos o vo da porta (1 e 2 pontos) e o
; 3 ponto indicando o lado da sua abertura
; O 1 ponto  o ponto de charneira da porta.
; Esta macro deve servir para escalas a 1/100 e inferiores. Por exemplo: 1/200.
; Ao ser carregada para o autocad com "appload" a funo responde como um
; comando novo. 2019/2020

(defun c:porta3d () 
;estas trs funes so complementares servindo para
; guardar o valor da varivel do snap  2d e 3d
; a primeira serve para no se ver os comando executados na linha de comando
	(setvar "CMDECHO" 0)
	(setq ponto (getvar "osmode"))
	(setq 3dponto (getvar "3DOSMODE"))
	
;desliga o 3dsnap	
	(setvar "3dosmode" 0)
	
;deixa ativado o snap para "endpoint"
	(setvar "osmode" 1)
	
;obteno de pontos coordenadores
	(setq p1 (getpoint "\nIndique o ponto do lado da dobradia:  "))
	(setq p2 (getpoint "\nIndique o ponto do lado onde  o batente: "))
	(setq p3 (getpoint "\nIndique o ponto limite oposto ao 1 ponto que defina a espessura da parede: "))
	
;obteno de distncias gerais	
	(if	(= nill (setq altura (getdist "\nIndique a altura da porta com dois pontos: <2.100m>  ")))
		(setq altura 2.10)
		)	
	(if (= nill (setq espessura (getdist "\nIndique a espessura da porta: <0.035m> ")))
		(setq espessura 0.035)
		)
	(if (= nill (setq espessura_aro (getdist "\nIndique a espessura do aro: <0.01m> ")))
		(setq espessura_aro 0.01)
		)		
	(setq largura (distance p1 p3))
;desliga o snap
	(setvar "osmode" 0)

; desenhar a aduela e verga da porta
	(command "_pline" 	p1 
						p3
						(setq pa2 (polar p3 (angle p1 p2) espessura_aro))
						(setq pa3 (polar pa2 (angle p3 p1) (- largura espessura espessura_aro)))
						(setq pa4 (polar pa3 (angle p1 p2) espessura_aro))
						(setq pa5 (polar pa4 (angle p3 p1) espessura_aro))
						(setq pa6 (polar pa5 (angle p2 p1) espessura_aro))
						(setq pa7 (polar pa6 (angle p3 p1) espessura))
						"c"
						)
	(setq perfil (entlast))
	(command "_line" p1 
					(list (car p1) (cadr p1) (+ (caddr p1) (- altura 0.015))) 
					"")					
	(setq caminho_porta (entlast))

	(command "_pline" (polar pa7 (angle p1 p2) 0.005)
					 (polar pa6 (angle p1 p2) 0.005)
					 (polar pa6 (angle p1 p2) (- (distance p1 p2) (+ (* espessura_aro 2) 0.01)))
					 (polar pa7 (angle p1 p2) (- (distance p1 p2) (+ (* espessura_aro 2) 0.01)))
					 "_c"
				)
	(setq porta (entlast))

	(command "_3dpoly" p1
					(list (car p1) (cadr p1) (+ (caddr p1) altura ))
					(list (car p2) (cadr p2) (+ (caddr p2) altura ))
					p2 
					""
					)
	(setq caminho_aduela (entlast))
;criar os 2 slidos finais: o aro e a porta
	(command "_extrude" perfil "" "_path" caminho_aduela)
	(command "_extrude" porta  "" "_path" caminho_porta)	

(command "_erase" perfil porta caminho_aduela caminho_porta "")

;estas duas linhas servem para repor o UCS principal
; e para repor o valor da varivel do snap
	(setvar "osmode" ponto)
	(setvar "3DOSMODE" 3dponto)
	(setvar "CMDECHO" 1)
) 
